﻿using System;
using System.Configuration;
using System.ServiceModel;
using Microsoft.ServiceBus;
using AppFabricOnPremise.Services;

namespace AppFabricOnPremise
{
    public class Global : System.Web.HttpApplication
    {
        private ServiceHost host;

        protected void Application_Start(object sender, EventArgs e)
        {            
            var address = ServiceBusEnvironment.CreateServiceUri(
                "sb",
                ConfigurationManager.AppSettings["ServiceNamespace"],
                "BookService"
            );

            var cred = new TransportClientEndpointBehavior();
            cred.CredentialType = TransportClientCredentialType.SharedSecret;
            cred.Credentials.SharedSecret.IssuerName =
                    ConfigurationManager.AppSettings["IssuerName"];
            cred.Credentials.SharedSecret.IssuerSecret =
                    ConfigurationManager.AppSettings["IssuerSecret"];

            var setting = new ServiceRegistrySettings(DiscoveryType.Public);

            host = new ServiceHost(typeof(BookService), address);

            foreach (var ep in host.Description.Endpoints)
            {
                ep.Behaviors.Add(cred);
                ep.Behaviors.Add(setting);
            }
            host.Open();
        }

        protected void Application_End(object sender, EventArgs e)
        {
            host.Close();
        }
    }
}