﻿using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;


namespace CloudSession
{
    public class WorkerRole : RoleEntryPoint
    {
        public override void Run()
        {
            using (var db = new SqlConnection(ConfigurationManager.ConnectionStrings["MyDB"].ConnectionString))
            {                
                SqlCommand comm = new SqlCommand()
                {
                    Connection = db,
                    CommandText = "DeleteExpiredSessions",
                    CommandType = CommandType.StoredProcedure
                };
                while (true)
                {                    
                    Thread.Sleep(10000);
                    try
                    {
                        db.Open();
                        var del = comm.ExecuteScalar();
                        db.Close();
                    }
                    catch (SqlException e)
                    {
                        Trace.TraceError("Error occured:" + e.Message);
                        if (db.State != ConnectionState.Closed)
                        {
                            db.Close();
                        }
                    }
                }
            }            
        }

        public override bool OnStart()
        {
            // Set the maximum number of concurrent connections 
            ServicePointManager.DefaultConnectionLimit = 12;

            DiagnosticMonitor.Start("DiagnosticsConnectionString");

            // For information on handling configuration changes
            // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
            RoleEnvironment.Changing += RoleEnvironmentChanging;

            return base.OnStart();
        }

        private void RoleEnvironmentChanging(object sender, RoleEnvironmentChangingEventArgs e)
        {
            // If a configuration setting is changing
            if (e.Changes.Any(change => change is RoleEnvironmentConfigurationSettingChange))
            {
                // Set e.Cancel to true to restart this role instance
                e.Cancel = true;
            }
        }
    }
}
