﻿using System;
using System.Linq;
using System.Net;
using System.ServiceModel;
using System.Threading;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;


namespace CloudTcp
{
    public class WorkerRole : RoleEntryPoint
    {
        public override void Run()
        {
            var host = new ServiceHost(typeof(HelloService));
            host.AddServiceEndpoint(
            typeof(IHelloContract),
            new NetTcpBinding(SecurityMode.None),
            String.Format("net.tcp://{0}/HelloService",
                RoleEnvironment.CurrentRoleInstance.
                    InstanceEndpoints["MyEnd"].IPEndpoint)
            );
            host.Open();

            while (true)
            {
            Thread.Sleep(10000);
            }
                }

        public override bool OnStart()
        {
            // Set the maximum number of concurrent connections 
            ServicePointManager.DefaultConnectionLimit = 12;

            DiagnosticMonitor.Start("DiagnosticsConnectionString");

            // For information on handling configuration changes
            // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
            RoleEnvironment.Changing += RoleEnvironmentChanging;

            return base.OnStart();
        }

        private void RoleEnvironmentChanging(object sender, RoleEnvironmentChangingEventArgs e)
        {
            // If a configuration setting is changing
            if (e.Changes.Any(change => change is RoleEnvironmentConfigurationSettingChange))
            {
                // Set e.Cancel to true to restart this role instance
                e.Cancel = true;
            }
        }
    }
}
