﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace CloudUI.Chap3
{
  public partial class BlockUpload : System.Web.UI.Page
  {
    protected void btnUpload_Click(object sender, EventArgs e)
    {
      CloudStorageAccount account = CloudStorageAccount.FromConfigurationSetting("MyStorage");
      var _cli = account.CreateCloudBlobClient();
      _cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500));
      var container = _cli.GetContainerReference("images");
      var blob = container.GetBlockBlobReference("sample.jpg");      
      blob.PutBlock(Base64("b1"), up1.PostedFile.InputStream, null);
      blob.PutBlock(Base64("b2"), up2.PostedFile.InputStream, null);
      blob.PutBlock(Base64("b3"), up3.PostedFile.InputStream, null);
      blob.PutBlockList(new List<String>() {
        Base64("b1"), Base64("b2"), Base64("b3") });
      blob.Properties.ContentType = "image/jpeg";
      blob.SetProperties();
    }

    private string Base64(String id) {
      return Convert.ToBase64String(
        Encoding.GetEncoding("UTF-8").GetBytes(id));
    }
  }
}