﻿using System;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace CloudUI.Chap3
{
    public partial class ListSegment : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            CloudStorageAccount account = CloudStorageAccount.FromConfigurationSetting("MyStorage");
            var cli = account.CreateCloudBlobClient();
            cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500));
            var container = cli.GetContainerReference("images");
            ResultContinuation cont = null;
            do
            {
                var list = container.ListBlobsSegmented(5, cont,
                    new BlobRequestOptions() { UseFlatBlobListing = true });
                cont = list.ContinuationToken;
                foreach (var item in list.Results)
                {
                    Response.Write(item.Uri + "<br />");
                }
                Response.Write("<hr />");
            } while (cont != null);
        }
    }
}