﻿using System;
using System.IO;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace CloudUI.Chap3
{
    public partial class PageShow : System.Web.UI.Page
    {
        private const int PAGE_SIZE = 512;
        private const int PAGE_COUNT = 1024;

        protected void Page_Load(object sender, EventArgs e)
        {
            var start = 0;
            if (Request.QueryString["id"] != null)
            {
                start = Int32.Parse(Request.QueryString["id"]);
            }
            CloudStorageAccount account = CloudStorageAccount.FromConfigurationSetting("MyStorage");
            var _cli = account.CreateCloudBlobClient();
            _cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500));
            var container = _cli.GetContainerReference("images");
            var blob = container.GetPageBlobReference("pages");
            using (BlobStream stream = blob.OpenRead())
            {
                stream.Seek(start * PAGE_SIZE * PAGE_COUNT, SeekOrigin.Begin);
                byte[] buff = new byte[PAGE_SIZE * PAGE_COUNT];
                stream.Read(buff, 0, buff.Length);
                Response.BinaryWrite(buff);
            }
        }
    }
}