﻿using System;
using System.IO;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

namespace CloudUI.Chap3
{
    public partial class PageUpload : System.Web.UI.Page
    {
        private const int PAGE_SIZE = 512;
        private const int PAGE_COUNT = 1024;

        protected void btnUpload_Click(object sender, EventArgs e)
        {
            var account = CloudStorageAccount.FromConfigurationSetting("MyStorage");
            var _cli = account.CreateCloudBlobClient();
            _cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500));
            var container = _cli.GetContainerReference("images");
            var blob = container.GetPageBlobReference("pages");
            this.Write(blob, up1, 0);
            this.Write(blob, up2, 1);
            this.Write(blob, up3, 2);
        }

        private void Write(CloudPageBlob p, FileUpload upload, int start)
        {
            if (upload.HasFile)
            {
                var fl = upload.PostedFile;
                byte[] buff = new byte[PAGE_SIZE * PAGE_COUNT];
                fl.InputStream.Read(buff, 0, fl.ContentLength);
                using (var stream = new MemoryStream(buff))
                {
                    p.WritePages(stream, start * PAGE_SIZE * PAGE_COUNT);
                }
            }
        }
    }
}