﻿using System;
using System.Data.Services.Client;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using CloudUI.Models;


namespace CloudUI.Chap4
{
    public partial class Paging : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
 			var p = Request.QueryString["p"];
			var r = Request.QueryString["r"];
	
			CloudStorageAccount account = CloudStorageAccount.FromConfigurationSetting("MyStorage");
			CloudTableClient table = account.CreateCloudTableClient();
			table.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500));
			var context = table.GetDataServiceContext();

			var query = (DataServiceQuery<Message>)context.CreateQuery<Message>("Message").Take(5);
			if (!String.IsNullOrEmpty(p))
			{
				query = query.AddQueryOption("NextPartitionKey", p);
				if (!String.IsNullOrEmpty(r))
				{
					query = query.AddQueryOption("NextRowKey", r);
				}
			}
			var response = (QueryOperationResponse)query.Execute();
			grid.DataSource = response;
			grid.DataBind();

			var linkurl = "Paging.aspx?";
			if (response.Headers.ContainsKey("x-ms-continuation-NextPartitionKey"))
			{
				linkurl += "p=" + response.Headers["x-ms-continuation-NextPartitionKey"] + "&";
				if (response.Headers.ContainsKey("x-ms-continuation-NextRowKey"))
				{
					linkurl += "r=" + response.Headers["x-ms-continuation-NextRowKey"];
				}
				lnkNext.NavigateUrl = linkurl;
				lnkNext.Visible = true;
			}
        }
    }
}