﻿using System;
using System.ServiceModel;
using System.Text;
using Microsoft.WindowsAzure.ServiceRuntime;
using CloudTcp;

namespace CloudUI.Chap4
{
    public partial class TcpClient : System.Web.UI.Page
    {
        protected void btnSend_Click(object sender, EventArgs e)
        {
            var builder = new StringBuilder();
	        foreach (var instance in RoleEnvironment.Roles["CloudTcp"].Instances)
	        {

			        var ep = instance.InstanceEndpoints["MyEnd"].IPEndpoint;

			        var factory = new ChannelFactory<IHelloChannel>(
				        new NetTcpBinding(SecurityMode.None),
				        new EndpointAddress(
					        String.Format("net.tcp://{0}/HelloService", ep))
			        );
			        IHelloChannel channel = factory.CreateChannel();

			        channel.Open();
			        var str = channel.GetMessage(txtName.Text);
			        builder.Append(String.Format("<p>[{0}] {1}</p>", ep, str));
			        channel.Close();
	        }
	        lblGreet.Text = builder.ToString();
        }
    }
}