﻿using System;
using System.Configuration;
using System.ServiceModel;
using Microsoft.ServiceBus;
using AppFabricOnPremise.Services;

namespace CloudUI.Chap6
{
    public partial class AppFabricClient : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var address = ServiceBusEnvironment.CreateServiceUri(
                "sb",
                 ConfigurationManager.AppSettings["ServiceNamespace"],
                "BookService"
              );

			var cred = new TransportClientEndpointBehavior();
			cred.CredentialType = TransportClientCredentialType.SharedSecret;
			cred.Credentials.SharedSecret.IssuerName =
				ConfigurationManager.AppSettings["IssuerName"];
			cred.Credentials.SharedSecret.IssuerSecret =
				ConfigurationManager.AppSettings["IssuerSecret"];
	
			var factory = new ChannelFactory<IBookChannel>(
				"FabricEndpoint", new EndpointAddress(address));
            factory.Endpoint.Binding = new NetTcpRelayBinding();
            factory.Endpoint.Behaviors.Add(cred);
			IBookChannel channel = factory.CreateChannel();
	
			channel.Open();
			gridBook.DataSource = channel.GetBookInfoByPublish(
                ddlPublish.SelectedValue);
			gridBook.DataBind();
	
			channel.Close();
			factory.Close();
		}
    }
}
