﻿Imports Microsoft.ServiceBus
Imports AppFabricOnPremise.Services

Public Class Global_asax
    Inherits System.Web.HttpApplication

    Private host As ServiceHost

    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        Dim address = ServiceBusEnvironment.CreateServiceUri(
            "sb",
            ConfigurationManager.AppSettings("ServiceNamespace"),
            "BookService"
        )

        Dim cred = New TransportClientEndpointBehavior()
        cred.CredentialType = TransportClientCredentialType.SharedSecret
        cred.Credentials.SharedSecret.IssuerName =
            ConfigurationManager.AppSettings("IssuerName")
        cred.Credentials.SharedSecret.IssuerSecret =
            ConfigurationManager.AppSettings("IssuerSecret")

        Dim setting = New ServiceRegistrySettings(DiscoveryType.Public)

        host = New ServiceHost(GetType(BookService), address)

        For Each ep In host.Description.Endpoints
            ep.Behaviors.Add(cred)
            ep.Behaviors.Add(setting)
        Next
        host.Open()
    End Sub

    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        host.Close()
    End Sub

End Class