﻿Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Net
Imports System.Threading
Imports Microsoft.WindowsAzure.Diagnostics
Imports Microsoft.WindowsAzure.ServiceRuntime

Public Class WorkerRole
    Inherits RoleEntryPoint

    Public Overrides Sub Run()

        Using db = New SqlConnection(ConfigurationManager.ConnectionStrings("MyDB").ConnectionString)

            Dim comm = New SqlCommand() With
            {
                .Connection = db,
                .CommandText = "DeleteExpiredSessions",
                .CommandType = CommandType.StoredProcedure
            }

            While (True)
                Thread.Sleep(10000)
                Try
                    db.Open()
                    comm.ExecuteScalar()
                    db.Close()
                Catch e As SqlException
                    Trace.TraceError("Error occured:" + e.Message)
                    If db.State <> ConnectionState.Closed Then
                        db.Close()
                    End If

                End Try
            End While
        End Using

    End Sub

    Public Overrides Function OnStart() As Boolean

        ' Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit = 12

        DiagnosticMonitor.Start("DiagnosticsConnectionString")

        ' For information on handling configuration changes
        ' see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
        AddHandler RoleEnvironment.Changing, AddressOf RoleEnvironmentChanging

        Return MyBase.OnStart()

    End Function

    Private Sub RoleEnvironmentChanging(ByVal sender As Object, ByVal e As RoleEnvironmentChangingEventArgs)

        ' If a configuration setting is changing
        If (e.Changes.Any(Function(change) TypeOf change Is RoleEnvironmentConfigurationSettingChange)) Then
            ' Set e.Cancel to true to restart this role instance
            e.Cancel = True
        End If

    End Sub

End Class
