﻿Imports System.Net
Imports System.Threading
Imports System.ServiceModel
Imports Microsoft.WindowsAzure.Diagnostics
Imports Microsoft.WindowsAzure.ServiceRuntime
Imports CloudTcp

Public Class WorkerRole
    Inherits RoleEntryPoint

    Public Overrides Sub Run()

        Dim host = New ServiceHost(GetType(HelloService))
        host.AddServiceEndpoint(
            GetType(IHelloContract),
            New NetTcpBinding(SecurityMode.None),
            String.Format("net.tcp://{0}/HelloService",
                RoleEnvironment.CurrentRoleInstance.
                    InstanceEndpoints("MyEnd").IPEndpoint)
            )
        host.Open()

        While (True)
            Thread.Sleep(10000)
        End While

    End Sub

    Public Overrides Function OnStart() As Boolean

        ' Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit = 12

        DiagnosticMonitor.Start("DiagnosticsConnectionString")

        ' For information on handling configuration changes
        ' see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
        AddHandler RoleEnvironment.Changing, AddressOf RoleEnvironmentChanging

        Return MyBase.OnStart()

    End Function

    Private Sub RoleEnvironmentChanging(ByVal sender As Object, ByVal e As RoleEnvironmentChangingEventArgs)

        ' If a configuration setting is changing
        If (e.Changes.Any(Function(change) TypeOf change Is RoleEnvironmentConfigurationSettingChange)) Then
            ' Set e.Cancel to true to restart this role instance
            e.Cancel = True
        End If

    End Sub

End Class
