﻿Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.StorageClient

Public Class BlockUpload
    Inherits System.Web.UI.Page

    Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnUpload.Click
        Dim account = CloudStorageAccount.FromConfigurationSetting("MyStorage")
        Dim _cli = account.CreateCloudBlobClient()
        _cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500))
        Dim container = _cli.GetContainerReference("images")
        Dim blob = container.GetBlockBlobReference("sample.jpg")
        blob.PutBlock(Base64("b1"), up1.PostedFile.InputStream, Nothing)
        blob.PutBlock(Base64("b2"), up2.PostedFile.InputStream, Nothing)
        blob.PutBlock(Base64("b3"), up3.PostedFile.InputStream, Nothing)
        blob.PutBlockList(New List(Of String) From
        {
            Base64("b1"), Base64("b2"), Base64("b3")
        })
        blob.Properties.ContentType = "image/jpeg"
        blob.SetProperties()
    End Sub

    Private Function Base64(ByVal id As String) As String
        Return Convert.ToBase64String(
            Encoding.GetEncoding("UTF-8").GetBytes(id))
    End Function
End Class