﻿Imports System.IO
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.StorageClient

Public Class PageUpload
    Inherits System.Web.UI.Page

    Private Const PAGE_SIZE As Integer = 512
    Private Const PAGE_COUNT As Integer = 1024

    Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnUpload.Click
        Dim account = CloudStorageAccount.FromConfigurationSetting("MyStorage")
        Dim _cli = account.CreateCloudBlobClient()
        _cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500))
        Dim container = _cli.GetContainerReference("images")
        Dim blob = container.GetPageBlobReference("pages")
        Me.Write(blob, up1, 0)
        Me.Write(blob, up2, 1)
        Me.Write(blob, up3, 2)
    End Sub

    Private Sub Write(ByVal p As CloudPageBlob,
        ByVal upload As FileUpload, ByVal start As Integer)
        If upload.HasFile Then
            Dim fl = upload.PostedFile
            Dim buff() As Byte = New Byte(PAGE_SIZE * PAGE_COUNT - 1) {}
            fl.InputStream.Read(buff, 0, fl.ContentLength)
            Using stream = New MemoryStream(buff)
                p.WritePages(stream, start * PAGE_SIZE * PAGE_COUNT)
            End Using
        End If
    End Sub
End Class