﻿Imports System.Data.Services.Client
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.StorageClient
Imports CloudUI.Models


Public Class Paging
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim p = Request.QueryString("p")
        Dim r = Request.QueryString("r")

        Dim account = CloudStorageAccount.FromConfigurationSetting("MyStorage")
        Dim table = account.CreateCloudTableClient()
        table.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500))
        Dim context = table.GetDataServiceContext()

        Dim query = DirectCast(context.CreateQuery(Of Message)("Message").Take(5), DataServiceQuery(Of Message))
        If Not String.IsNullOrEmpty(p) Then
            query = query.AddQueryOption("NextPartitionKey", p)
            If Not String.IsNullOrEmpty(r) Then
                query = query.AddQueryOption("NextRowKey", r)
            End If
        End If
        Dim response = DirectCast(query.Execute(), QueryOperationResponse)
        grid.DataSource = response
        grid.DataBind()

        Dim linkurl = "Paging.aspx?"
        If response.Headers.ContainsKey("x-ms-continuation-NextPartitionKey") Then
            linkurl &= "p=" & response.Headers("x-ms-continuation-NextPartitionKey") & "&"
            If response.Headers.ContainsKey("x-ms-continuation-NextRowKey") Then
                linkurl &= "r=" & response.Headers("x-ms-continuation-NextRowKey")
            End If
            lnkNext.NavigateUrl = linkurl
            lnkNext.Visible = True
        End If
    End Sub

End Class