﻿Imports Microsoft.ServiceBus
Imports System.ServiceModel
Imports AppFabricOnPremise.Services

Public Class AppFabricClient
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim address = ServiceBusEnvironment.CreateServiceUri(
            "sb",
             ConfigurationManager.AppSettings("ServiceNamespace"),
            "BookService"
        )

        Dim cred = New TransportClientEndpointBehavior()
        cred.CredentialType = TransportClientCredentialType.SharedSecret
        cred.Credentials.SharedSecret.IssuerName =
            ConfigurationManager.AppSettings("IssuerName")
        cred.Credentials.SharedSecret.IssuerSecret =
            ConfigurationManager.AppSettings("IssuerSecret")

        Dim factory = New ChannelFactory(Of IBookChannel)(
            "FabricEndpoint", New EndpointAddress(address))
        factory.Endpoint.Binding = New NetTcpRelayBinding()
        factory.Endpoint.Behaviors.Add(cred)

        Dim channel As IBookChannel = factory.CreateChannel()
        channel.Open()
        gridBook.DataSource = channel.GetBookInfoByPublish(
            ddlPublish.SelectedValue)
        gridBook.DataBind()
        channel.Close()
        factory.Close()
    End Sub

End Class