﻿Imports System.IO
Imports Microsoft.WindowsAzure.StorageClient
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.ServiceRuntime

Namespace Models
    Public Class DriveData
        Private drive As CloudDrive

        Public Sub New()
            Dim account = CloudStorageAccount.FromConfigurationSetting("MyStorage")
            Dim blob_cli = account.CreateCloudBlobClient()
            blob_cli.RetryPolicy = RetryPolicies.Retry(3, TimeSpan.FromMilliseconds(500))
            Dim c = blob_cli.GetContainerReference("drives")
            Dim page = c.GetPageBlobReference("mydrive")
            Dim localCache = RoleEnvironment.GetLocalResource("MyCache")
            CloudDrive.InitializeCache(localCache.RootPath,
                localCache.MaximumSizeInMegabytes)
            drive = New CloudDrive(page.Uri, account.Credentials)
        End Sub

        Public Sub UpdateMemo(ByVal name As String, ByVal body As String)
            Dim letter = drive.Mount(10, DriveMountOptions.None)
            Dim path = String.Format("{0}/{1}", letter, name)
            Using writer = New StreamWriter(path)
                writer.Write(body)
            End Using
            drive.Unmount()
        End Sub

        Public Function GetMemoByName(ByVal name As String) As String
            Dim letter = drive.Mount(10, DriveMountOptions.None)
            Dim path = String.Format("{0}/{1}", letter, name)
            Dim result = ""
            If File.Exists(path) Then
                Using reader = New StreamReader(path)
                    result = reader.ReadToEnd()
                End Using
            End If
            drive.Unmount()
            Return result
        End Function
    End Class
End Namespace

